// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package org.zcu.fav.kiv.pia.slezacek.controller;

import java.io.UnsupportedEncodingException;
import java.lang.Integer;
import java.lang.Long;
import java.lang.String;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.joda.time.format.DateTimeFormat;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;
import org.zcu.fav.kiv.pia.slezacek.model.Repair;
import org.zcu.fav.kiv.pia.slezacek.model.Users;
import org.zcu.fav.kiv.pia.slezacek.model.Vehicle;

privileged aspect RepairController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String RepairController.create(@Valid Repair repair, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("repair", repair);
            addDateTimeFormatPatterns(model);
            return "repairs/create";
        }
        repair.persist();
        return "redirect:/repairs/" + encodeUrlPathSegment(repair.getId().toString(), request);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String RepairController.createForm(Model model) {
        model.addAttribute("repair", new Repair());
        addDateTimeFormatPatterns(model);
        List dependencies = new ArrayList();
        if (Users.countUserses() == 0) {
            dependencies.add(new String[]{"person", "userses"});
        }
        model.addAttribute("dependencies", dependencies);
        return "repairs/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String RepairController.show(@PathVariable("id") Long id, Model model) {
        addDateTimeFormatPatterns(model);
        model.addAttribute("repair", Repair.findRepair(id));
        model.addAttribute("itemId", id);
        return "repairs/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String RepairController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            model.addAttribute("repairs", Repair.findRepairEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Repair.countRepairs() / sizeNo;
            model.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            model.addAttribute("repairs", Repair.findAllRepairs());
        }
        addDateTimeFormatPatterns(model);
        return "repairs/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String RepairController.update(@Valid Repair repair, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("repair", repair);
            addDateTimeFormatPatterns(model);
            return "repairs/update";
        }
        repair.merge();
        return "redirect:/repairs/" + encodeUrlPathSegment(repair.getId().toString(), request);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String RepairController.updateForm(@PathVariable("id") Long id, Model model) {
        model.addAttribute("repair", Repair.findRepair(id));
        addDateTimeFormatPatterns(model);
        return "repairs/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String RepairController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        Repair.findRepair(id).remove();
        model.addAttribute("page", (page == null) ? "1" : page.toString());
        model.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/repairs?page=" + ((page == null) ? "1" : page.toString()) + "&size=" + ((size == null) ? "10" : size.toString());
    }
    
    @ModelAttribute("userses")
    public Collection<Users> RepairController.populateUserses() {
        return Users.findAllUserses();
    }
    
    @ModelAttribute("vehicles")
    public Collection<Vehicle> RepairController.populateVehicles() {
        return Vehicle.findAllVehicles();
    }
    
    void RepairController.addDateTimeFormatPatterns(Model model) {
        model.addAttribute("repair_reapirdate_date_format", DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
    }
    
    String RepairController.encodeUrlPathSegment(String pathSegment, HttpServletRequest request) {
        String enc = request.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
